// VTVSerialDemoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "VTVSerialDemo.h"
#include "VTVSerialDemoDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVTVSerialDemoDlg dialog

CVTVSerialDemoDlg::CVTVSerialDemoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CVTVSerialDemoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CVTVSerialDemoDlg)
	m_XmitStr = _T("");
	m_Port = 0;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CVTVSerialDemoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CVTVSerialDemoDlg)
	DDX_Control(pDX, IDC_CLOSEPORT, m_ClosePortCtrl);
	DDX_Control(pDX, IDC_OPENPORT, m_OpenPortCtrl);
	DDX_Control(pDX, IDC_LIST1, m_List);
	DDX_Text(pDX, IDC_XMIT, m_XmitStr);
	DDX_Text(pDX, IDC_PORT, m_Port);
	DDV_MinMaxInt(pDX, m_Port, 1, 8);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CVTVSerialDemoDlg, CDialog)
	//{{AFX_MSG_MAP(CVTVSerialDemoDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_OPENPORT, OnOpenPort)
	ON_BN_CLICKED(IDC_SEND, OnSendData)
	ON_BN_CLICKED(IDC_CLEAR, OnClear)
	ON_BN_CLICKED(IDC_CLOSEPORT, OnCloseport)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVTVSerialDemoDlg message handlers

BOOL CVTVSerialDemoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	m_Port = 1;
	UpdateData (false);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CVTVSerialDemoDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CVTVSerialDemoDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CVTVSerialDemoDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CVTVSerialDemoDlg::OnOpenPort() 
{
	// Open the comm port.  Disable the Connect button, and Enable the Disconnect button if sucessful
	//   Disable the disconnect button and enable the connect button if this fails.
	UpdateData (TRUE);

	// Make sure the comm port is already closed before reopening
	m_Serial.ShutDown();
	if (m_Serial.InitComm(m_Port, 19200, PARITY_NONE, DATABITS_8, STOPBITS_10) == 1)
	{
		m_OpenPortCtrl.EnableWindow(FALSE);
		m_ClosePortCtrl.EnableWindow(TRUE);
	}
	else
	{
		m_OpenPortCtrl.EnableWindow(TRUE);
		m_ClosePortCtrl.EnableWindow(FALSE);
	}


}

void CVTVSerialDemoDlg::OnSendData() 
{
	CString OutBuffer;
	CString InBuffer;
	UpdateData (TRUE);
	
	OutBuffer = m_XmitStr;
	OutBuffer += "\r";

	m_Serial.Send(OutBuffer);
	m_Serial.Receive(InBuffer);
	
	InBuffer.TrimRight();

	if (InBuffer.IsEmpty() == TRUE)
		InBuffer = "Serial Error";

	m_List.AddString(InBuffer);

	UpdateData (FALSE);

}

void CVTVSerialDemoDlg::OnClear() 
{
	m_List.ResetContent();
	
}


void CVTVSerialDemoDlg::OnCloseport() 
{

	// Close the comm port, and reactivate the Connect button	
	m_Serial.ShutDown();
	m_OpenPortCtrl.EnableWindow(TRUE);
	m_ClosePortCtrl.EnableWindow(FALSE);
	
}
